/* UpTools v8.5
 *
 * Copyright (c) 2005-2010 Fundacion Universidad de Palermo (Argentina).
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 *
 * 3. Neither the name of the copyright holder nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * 4. Redistributions of any form whatsoever must retain the following
 *    acknowledgment: 'This product includes software developed by the
 *    "Universidad de Palermo, Argentina" (http://www.palermo.edu/).'
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT 
 * HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED
 * TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 * PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
 * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 * NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#include <string>
#include <iostream>
#include <UpTools/UpThread.h>
#include <UpTools/UpLog.h>
#include "unistd.h"


UpMutex m1;
std::string readString;





class MyThread : public UpThread {
public:
	void* run() {
		m1.lock();
		std::cout<< "Thread 1: counting to 10" << std::endl;
		m1.unlock();
		for(int i=1;i<=10;i++) {
			usleep(500000);
			m1.lock();
X			std::cout << "Thread 1 count: "<< i << std::endl;
			m1.unlock();
		}
		return (void*)"regards from thread 1";
	}
};


int main(int argc, char* argv[]) {
	MyThread th;
	th.create();
	upOpenLogFile("testUpThread",LOG_THID,"stderr",LOG_DEBUG);
	sleep(2);
	m1.lock();
	std::cout<< "Thread 0: locking mutex while counting to 5..." << std::endl;
	for(int i=1;i<=5;i++) {
		usleep(500000);
X		std::cout << "Thread 0 count: "<< i << std::endl;
	}
	std::cout<< "Thread 0: unlocking mutex..." << std::endl;
	m1.unlock();
	char* chau = (char*)th.join();
	std::cout << "Thread 0: join message from thread 1: " << chau << std::endl;
	
	return 0;
}

